/**
 * 	@Author Rahul Jonna <rjonna@rjonna.com>
 *	@Version 1.0
 *	@copyright www.rjonna.com	
 */
 
//get the preferences when showing the dialog box
function LoadBookmarkOptions()
{
	var userid = document.getElementById("gUserName").value = gbmPrefHandler.getPref(gbmPrefNames.prefUserName, "char");
	var pwd = jsBMUtils.getPassword(userid);
	document.getElementById("gPwd").value = pwd;
	document.getElementById("gRemember").checked = (gbmPrefHandler.getPref(gbmPrefNames.prefRememberPwd, "char") == "true") ? true : false;
	if (document.getElementById("gRemember").checked)
	{
		document.getElementById("gAutomaticSignIn").disabled = false;
		document.getElementById("gAutomaticSignIn").checked = (gbmPrefHandler.getPref(gbmPrefNames.prefAutoSign, "char") == "true") ? true : false;
	}
	
	var sortSelectedItem = gbmPrefHandler.getPref(gbmPrefNames.prefSort, "char");
	if (sortSelectedItem == "" || sortSelectedItem == "0")
	{
		document.getElementById("gbSort").selectedIndex = 0;
	}
	else
		document.getElementById("gbSort").selectedIndex = 1;
	
}

function DisableAutoSignIn()
{
	if (document.getElementById("gRemember").checked)
		document.getElementById("gAutomaticSignIn").disabled = false;
	else
		document.getElementById("gAutomaticSignIn").disabled = true;
}


//set the preferences when the "OK" button is pressed in the dialog box
function doOK()
{
	try
	{
		if (importProgress == 1)
		{
			alert("Import is in progress. You cannot close this window until it is done...");
			return false;
		}
		
		var userName = jsBMUtils.trimWhitespace(document.getElementById("gUserName").value);
		//if (jsBMUtils.trimWhitespace(userName) == "")
		//{
		//	alert("UserName cannot be empty!");
		//	return false;
		//}
		var userPwd = document.getElementById("gPwd").value;
		//if (jsBMUtils.trimWhitespace(userPwd) == "")
		//	return false;

		gbmPrefHandler.setPref(gbmPrefNames.prefUserName, userName, "char");
		gbmPrefHandler.setPref(gbmPrefNames.prefRememberPwd, document.getElementById("gRemember").checked, "char");
		jsBMUtils.storePassword(userName, userPwd, document.getElementById("gRemember").checked);
		if (document.getElementById("gRemember").checked)
			gbmPrefHandler.setPref(gbmPrefNames.prefAutoSign, document.getElementById("gAutomaticSignIn").checked, "char");
		else
		{
			gbmPrefHandler.setPref(gbmPrefNames.prefAutoSign, "false", "char");
		}
		var sortIndex = document.getElementById("gbSort").selectedIndex;
		gbmPrefHandler.setPref(gbmPrefNames.prefSort, sortIndex, "char");
		
		return true;	
	}
	catch (ex)
	{
		alert(ex);
		return false;
	}
}

function doCancel()
{
	if (importProgress == 1)
	{
		var confirmImport = confirm("Import is in progress. Do you still want to close...");
		if (confirmImport)
			return true;
		else
			return false;
	}
	return true;
}

//Init Bookmarks.js Service
initServices();
initBMService();
const gNCNS = "http://home.netscape.com/NC-rdf#";

function bookmarkProperties (url, bmTitle, label)
{
	this.url = url;
	this.bmTitle = bmTitle;
	this.label = label;
}

var arrFFBookmarks, importProgress = 0;

//import firefox bookmarks
function ImportFirefoxBookmarks()
{
	var isLoggedIn = checkLogin();
	if (!isLoggedIn)
	{
		alert("You have to login to import any bookmarks...");
		return;
	}
	var confirmImport = confirm("Are you sure you want to import all the bookmarks? This step cannot be undone...");
	if (!confirmImport)
		return;
	else
	{
		importProgress = 1;
		var defaultLabel = "";
		var labelPrompt = prompt("Do you want your 'default' bookmarks in a folder? If so give a name or leave it blank...");
		if (labelPrompt != null)
			defaultLabel = labelPrompt;
		var urlArc = RDF.GetResource(gNCNS + "URL");
		var nameArc = RDF.GetResource(gNCNS + "Name");
			
		var AllBookmarksResources = BMDS.GetAllResources();
		
		arrFFBookmarks = new Array();
			
		while (AllBookmarksResources.hasMoreElements()) 
		{
			var urlRes = AllBookmarksResources.getNext().QueryInterface(kRDFRSCIID);
			
			var aParent = BMSVC.getParent(urlRes);
			var parentName = "";
			var parentType = "";
			if (aParent) 
			{
				parentName = BookmarksUtils.getProperty(aParent.Value, gNCNS + "Name");
				parentType = BookmarksUtils.resolveType(aParent);
				
				if (parentType.indexOf("Livemark") != -1 || jsBMUtils.trimWhitespace(parentType) == ""
					|| parentType == "PersonalToolbarFolder") 
					continue;
			}		
			else
				continue;				
			
			var target = BMDS.GetTarget(urlRes, urlArc, true);
			var nameTarget = BMDS.GetTarget(urlRes, nameArc, true);
			
			if (target)
			{
				var url = target.QueryInterface(kRDFLITIID).Value;
				var name = nameTarget.QueryInterface(kRDFLITIID).Value;
					
				//gBMDump("MENUUUU " + url + ", " + name + ", " + parentName + ", " + parentType);
				
				if (parentName == "Bookmarks Toolbar Folder" || parentName == "Firefox and Mozilla Links" 
					|| parentName == "Quick Searches")
					continue;
				if (jsBMUtils.trimWhitespace(parentName).toString().indexOf("Bookmarks") != -1)
					parentName = defaultLabel;	
				
				arrFFBookmarks.push(new  bookmarkProperties (url, name, parentName));
			}
		}
	}
	AddBookmarkToGoogle (-1);
}


function AddBookmarkToGoogle (count)
{
	try
	{
		count++;
		
		if (count >= arrFFBookmarks.length)
		{
			importProgress = 0;
			alert("Import Complete!");
			return;
		}
		var objResp = new WebResponse(0, "");
		var uri = "http://www.google.com/bookmarks/mark";	
		var bkmk = arrFFBookmarks[count].url;					
		var bmTitle = arrFFBookmarks[count].bmTitle;					
		var labels = arrFFBookmarks[count].label;					
		bkmk = escape(bkmk);
		bmTitle = escape(bmTitle);
		labels = escape(labels);
		var postData = "bkmk=" + bkmk + "&title=" + bmTitle + "&labels=" + labels;
		gBMDump(postData);
		
		xhttp.doAsyncPost(postData, "", function (objResp) 
										{ 
											if (objResp.eId > 0)
												alert(objResp.eMesg);	 
											AddBookmarkToGoogle(count); 
										}, uri);
		
	}
	catch (ex)
	{
		alert(ex);
	}
}


function checkLogin ()
{
	var cookieManager = Components.classes["@mozilla.org/cookiemanager;1"]
						.getService(Components.interfaces.nsICookieManager);

	var iter = cookieManager.enumerator;
	var gcookie = -1;
	while (iter.hasMoreElements())
	{
		var cookie = iter.getNext();
		if (cookie instanceof Components.interfaces.nsICookie)
		{
			
			if (cookie.host.indexOf("google.com") != -1)
			{
				//gBMDump("Cookies = " + cookie.host + ", " + cookie.name);
				if (cookie.name == "SID")
				{	
					gcookie = cookie.value;	
				}
			}
		}
	}
	if (gcookie != -1)
	{
		//myDump(gcookie, false);	
		return true;
	}
	else
	{
		return false;
	}
}
